#version 330

out vec4 fragColor;

uniform vec2 res;
uniform float time;

const float sharpness = 300;

mat2 rot(float a) {
        return mat2(
                cos(a), -sin(a),
                sin(a), cos(a)
        );
}

float circle(vec2 m, float r, vec2 p) {
        vec2 diff = m - p;
        float d = sqrt(dot(diff, diff));

        return clamp((r - d)*sharpness, 0.0, 1.0);
}

float circle_d(vec2 m, float r, vec2 p) {
        return circle(m, r, p) - circle(m, r - 1/sharpness, p);
}

void main(void) {
        vec2 m = res/2;
        float s = min(m.x, m.y);
        vec2 p = (gl_FragCoord.xy - m) / s;

        float scene = 0;

        for (int i = 1; i <= 50; i++) {
                float c = circle_d(vec2(0.5, 0) * rot(time/500/i), 0.1 + 0.005*i, p);
                scene = abs(scene - c);
        }

        fragColor = vec4(vec3(1, 1, 1) * scene, 1);
}
